#include <stdio.h>
#include <string.h>  
#include <avr/io.h>  
#include <avr/eeprom.h>  
  
#include "mmc.h"
#include "fat.h"
#include "usart.h"
#include <util/delay.h>
#include <avr/interrupt.h>

volatile int a;
int b;
int dl2;	
unsigned char Buffer[512];
unsigned char playBuffer[512];
uint8_t  bufferChanged;





ISR(TIMER2_OVF_vect)
{

	TCNT2=70;	

	if(a<512)
	{
	OCR1A = playBuffer[a];a++;
	}



                                 
     if(a==512)
	 {
	 }
	    
}










//Hauptprogramm
int main (void)
{
  //SYSCLK defined in usart.h
  //Initzialisierung der seriellen Schnittstelle

  
   TCCR2 |= (1<<CS21); // Start timer at Fcpu/8

   //Enable Overflow Interrupt Enable
   TIMSK|=(1<<TOIE2);

  

   dl2=0;  













  
  //Initialisierung der MMC/SD-Karte
  usart_write("System Ready!\r\n");  
  while ( mmc_init() !=0) //ist der Rckgabewert ungleich NULL ist ein Fehler aufgetreten
    {
    usart_write("** Keine MMC/SD Karte gefunden!! **\n");  
    }
  usart_write("Karte gefunden!!\n");
  
  fat_init();//laden Cluster OFFSET und Size
  //Initialisierung der MMC/SD-Karte ENDE!

    unsigned int tmp;
  
  mmc_read_csd (Buffer);
  
  for (tmp = 0;tmp<16;tmp++)
    {
    usart_write("%x ",Buffer[tmp]);
    };


  //Ausgabe des Root Directory
  unsigned int Clustervar;
  unsigned char Dir_Attrib = 0;
  unsigned long Size = 0;
  usart_write("\r\nDirectory\r\n");
  for (char a = 1;a < 240;a++)
  {
    Clustervar = fat_read_dir_ent(0,a,&Size,&Dir_Attrib,Buffer);
      if (Clustervar == 0xffff)
      {
        break;
      }
    tmp = (Size & 0x0000FFFF);
    usart_write("Cluster = %4x DirA = %2x FileName = ",Clustervar,Dir_Attrib);
    usart_write("%s",Buffer);
    usart_write("\r\n");
  }
  usart_write("\r\nDirectory Ende\r\n");


DDRA  &= ~(1<<PA3) | (1<<PA2)  | (1<<PA1) | (1<<PA0);  /* Pin PA3 als Eingang */
//PORTA |= (1<<PA3)  | (1<<PA2)  | (1<<PA1) | (1<<PA0);    /* internen Pull-Up an PA4 aktivieren */

DDRA |=  ( 1 << DDA7 );  //Port A7 als ausgang fr verstrkerrelais

PORTA &= ~(1<<PA7); //Verstrker aus


  
  // INIT PWM
    
    DDRD = (1 << PD5 );
    TCCR1A = (1<<COM1A1) | (0<<COM1A0) | (0<<WGM11)  | (1<<WGM10) ;
    TCCR1B = (0<<CS12)   | (0<<CS11)   | (1<<CS10);

  // INIT PWM ENDE

while (1)
  {
  // taste 3
   if  ( PINA & (1<<PINA3) ) // ist 1 ? 
   {
	
	
	//Lade Cluster fr das index.htm File in den Speicher 
    Clustervar = 0;//suche im Root Verzeichnis
    if (fat_search_file((unsigned char *)"ABAUF.WAV",&Clustervar,&Size,&Dir_Attrib,Buffer) == 1)
    {


	PORTA |= (1<<PA7);  //Verstrker ein

	b=0;    



	//Ersten Datensatz lesen
	fat_read_file (Clustervar,Buffer,b);
	memcpy (playBuffer,Buffer,512);
	a=0;
	b=1;





	 //Interruptcounter initialisieren
    TCNT2=70;

	sei();



    //Lese File aus File
   		 while(b<100)
      		{
      
	 		 	if(a==512)
	  			{
	 
				memcpy (playBuffer,Buffer,512);
				a=0;
	  			fat_read_file (Clustervar,Buffer,b);
	
				b++;
		
      			}
	  			}

	
		cli();



	  	PORTA &= ~(1<<PA7); //Verstrker aus
	
    }//search file abauf
   }//port A3
  }//endlosschleife 
}//main
